/*************************************************************/
/*													 */																	
/*			DLOG Code from Chapter Three of				 */
/*													 */																												
/*		*** The Macintosh Programming Primer, Volume II ***		 */
/*													 */																													
/*		Copyright 1990, 1996 Dave Mark, All Rights Reserved...	          */
/*													 */																
/*************************************************************/
/*************************************************************/
/*													 */																														
/*     			Code converted from THINK C to CodeWarrior		 */
/*                         										 */																											
/*						     by                   				 */		            
/*													 */																													
/*                  			      Mike Murry                        	    	          */
/*													 */																														
/*************************************************************/

#define			kBaseResID				400
#define			kNilPointer				0L
#define			kMoveToFront			( WindowPtr )-1L
#define			kRemoveAllEvents		0

#define			iOKItem				1
#define			iCancelItem			2
#define			iTextItem				4

#define			kTEEnterKey			3
#define			kTETabKey				9
#define			kTECarriageReturn		13
#define			kTECancelKey			46

/************************************************************/
/*          				Globals 			           		        */        	          	
/************************************************************/

Boolean			gDone;

/************************************************************/
/*          				Functions						        */                  	
/************************************************************/

void				ToolboxInit ( void );
pascal	Boolean	DLOGFilter ( );
void				DrawOKButton ( );
void				CenterDialog ( );

/*************************main******************************/

void		main ( void )
{

	DialogPtr				theDialog;
	short					itemHit, itemType;
	Handle				OKHandle, textHandle;
	Rect					itemRect;
	Str255				theText;
	ModalFilterUPP			modalEventFilterUPP;
	
	
	ToolboxInit ();
	
	theDialog = GetNewDialog ( kBaseResID, nil, kMoveToFront );
	
	GetDialogItem ( theDialog, iOKItem, &itemType, &OKHandle, &itemRect );
	GetDialogItem ( theDialog, iTextItem, &itemType, &textHandle, &itemRect );
	
	CenterDialog ( theDialog );
	ShowWindow ( theDialog );
	SetPort ( theDialog );
	DrawOKButton ( theDialog );
	
	gDone = false;
	
	while ( ! gDone )
	{
	
		GetDialogItemText ( textHandle, theText );
		
		if ( theText [ 0 ] == 0 )
		{
		
			HiliteControl ( ( ControlHandle )OKHandle, 255 );
			
		}
		
		else
		{
		
			HiliteControl ( ( ControlHandle )OKHandle, 0 );
			
		}
		
		modalEventFilterUPP = NewModalFilterProc ( DLOGFilter );
		
		ModalDialog ( modalEventFilterUPP, &itemHit );
		
		gDone = ( ( itemHit == iOKItem ) || ( itemHit == iCancelItem ) );
		
		
	}
	
	
}				
	
	
/************************TollboxInit********************************/

void	ToolboxInit ()
{

	InitGraf ( &qd.thePort );
	InitFonts();
	FlushEvents ( everyEvent, kRemoveAllEvents );
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs( kNilPointer );
	InitCursor();	
	
}
	

/************************DLOGFilter*******************************/

pascal	Boolean	DLOGFilter ( theDialog, event, iPtr )

DialogPtr		theDialog;
EventRecord	*event;
short			*iPtr;
{

	short			itemType;
	Rect			itemRect;
	Handle		item;
	Str255		tempStr;
	char			theChar;
	
	GetDialogItem ( theDialog, iTextItem, &itemType, &item, &itemRect );
	GetDialogItemText ( item, tempStr );
	
	if ( event -> what == keyDown )
	{
	
		theChar = ( event -> message & charCodeMask );
		
		if ( ( theChar == kTECarriageReturn ) || ( theChar == kTEEnterKey ) )
		{
		
			if ( tempStr [ 0 ] != 0 )
			{
			
				*iPtr = iOKItem;
				GetDialogItem ( theDialog, iOKItem, &itemType, &item, &itemRect );
				HiliteControl ( ( ControlHandle )item, 1 );
				return ( true );
				
			}
			
			else
			{
			
				*iPtr = iTextItem;
				return ( true );
				
			}
			
		}	
			
		if ( theChar == kTECancelKey )
		{
		
			*iPtr = iCancelItem;
			GetDialogItem ( theDialog, iCancelItem, &itemType, &item, &itemRect );
			HiliteControl ( ( ControlHandle )item, 2 );
			return ( true );
			
		}
		
	}
	
	return ( false );
	
}
	
/******************DrawOKButton******************************/

void		DrawOKButton ( theDialog )

DialogPtr		theDialog;
{

	short				itemType;
	Rect				itemRect;
	Handle			item;
	GrafPtr			oldPort;
	
	GetDialogItem ( theDialog, iOKItem, &itemType, &item, &itemRect );
	GetPort ( &oldPort );
	SetPort ( theDialog );
	
	PenSize ( 3, 3 );
	InsetRect ( &itemRect, -4, -4 );
	FrameRoundRect (&itemRect, 16, 16 );
	PenNormal ();
	
	SetPort ( oldPort );
	
}


/*****************CenterDialog********************************/

void		CenterDialog ( theDialog )

DialogPtr		theDialog;
{

	Rect			rect;
	int			width, height, sWidth, sHeight, h, v;
	
	rect = theDialog -> portRect;
	
	width = rect.right - rect.left;
	height = rect.bottom - rect.top;
	
	sWidth = &qd.screenBits.bounds.right  -  &qd.screenBits.bounds.left;
	sHeight = &qd.screenBits.bounds.bottom  -  &qd.screenBits.bounds.top;
	
	h = ( sWidth + width ) / 2;
	v = ( sHeight + height ) / 2;
	
	MoveWindow ( theDialog, h, v, false );
	
}						
