/************************************************************/
/*															*/
/*	ColorInfo Code from Chapter Four of						*/
/*															*/
/*	*** The Macintosh Programming Primer, Volume II ***		*/
/*															*/
/*	Copyright 1990, 1996 Dave Mark, All Rights Reserved...	*/
/*															*/
/************************************************************/
/************************************************************/
/*															*/
/*     Code converted from THINK C to CodeWarrior			*/
/*                         									*/
/*						   by                               */
/*															*/
/*                     Mike Murry                           */
/*															*/
/************************************************************/


#include <GestaltEqu.h>

#define 	kBaseResID				400
#define		kMoveToFront			( WindowPtr ) -1L
#define		kNoGoAway				false
#define 	kErrorALRTid			128
#define 	kNullFilterProc			NULL
#define		kVisible				true
#define		kNilRefCon				( long ) nil
#define		kIndexDevice			true
#define		kDirectDevice			false
#define		kRemoveAllEvents		0
#define		kNilPointer				0L


/************************************************************/
/*          			Functions                       	*/
/************************************************************/


void		ToolboxInit ( void );
int			GetPixelDepth ();
Boolean		HasColorQD( void );
void		DisplayColors ();
void		CenterWindow ();
void		DoError( Str255 errorString );



/*****************main**********************************************************/

void	main ( void )
{

	int			pixDepth;
	GDHandle	curDev;
	Rect		bounds;
	
	ToolboxInit ();
	
	if ( HasColorQD () )
	{
	
		curDev = GetDeviceList ();
		
		while ( curDev != 0L )
		{
		
			bounds = ( **curDev ).gdRect;
			
			pixDepth = GetPixelDepth ( curDev );
			
			switch ( pixDepth )
			{
			
				case 1:
					DisplayColors ( &bounds, 1, 2, 128, kIndexDevice );
					break;
					
				case 2:
					DisplayColors ( &bounds, 2, 2, 128, kIndexDevice );
					break;
					
				case 4:
					DisplayColors ( &bounds, 4, 4, 64, kIndexDevice );
					break;
					
				case 8:
					DisplayColors ( &bounds, 16, 16, 24, kIndexDevice );
					break;
					
				default:
					DisplayColors ( &bounds, 48, 48, 8, kDirectDevice );
					break;
					
			}
			
			curDev = GetNextDevice ( curDev );
			
		}
		
		while ( ! Button () );
		
	}
	
	else
	{
	
		DoError ( "\pThis machine does not support Color QuickDraw!" );
		
	}
	
}


/*****************ToolBoxInit**************************************************/

void	ToolboxInit ()
{

	InitGraf ( &qd.thePort );
	InitFonts();
	FlushEvents ( everyEvent, kRemoveAllEvents );
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs( 0L );
	InitCursor();	
	
}


/***************GetPixelDepth*************************************************/

int GetPixelDepth ( theDevice )

GDHandle		theDevice;
{

	PixMapHandle		screenPMapH;
	int					pixelDepth;
	
	screenPMapH	= ( **theDevice ).gdPMap;
	pixelDepth	= ( **screenPMapH ).pixelSize;
	
	return ( pixelDepth );
	
}


/****************** HasColorQD **********************************************/

Boolean	HasColorQD( void )
{
	unsigned char	version[ 4 ];
	OSErr			err;
	
	err = Gestalt( gestaltQuickdrawVersion, (long *)version );
	
	if ( version[ 2 ] > 0 )
		return( true );
	else
		return( false );
}


/***************DisplayColors*************************************************/

void	DisplayColors ( boundsPtr, width, height, pixPerBox, isIndex )

Rect		*boundsPtr;
int			width, height, pixPerBox;
Boolean		isIndex;
{

	Rect			r;
	int				row, col;
	WindowPtr		cWindow;
	RGBColor		curColor;
	HSVColor		hsvColor;
	long			colorNum;
	
	hsvColor.value = hsvColor.saturation = 65535;
	
	r.top		= 0;
	r.left		= 0;
	r.right		= width * pixPerBox;
	r.bottom	= height * pixPerBox;
	
	
	cWindow = NewCWindow ( kNilPointer, &r, "\pDevice Colors ", kVisible, noGrowDocProc, kMoveToFront, kNoGoAway, kNilRefCon );

	CenterWindow ( cWindow, boundsPtr );
	ShowWindow ( cWindow );
	SetPort ( cWindow );
	
	for ( row = 0; row < height; row++ )
	{  	
	
		for ( col = 0; col < width; col++ )
		{
		
			r.top		= row * pixPerBox;
			r.left		= col * pixPerBox;
			r.bottom	= r.top + pixPerBox;
			r.right		= r.left + pixPerBox;
			
			if ( isIndex )
			{
			
				Index2Color ( ( long ) ( row * width + col ), &curColor );
				
			}
			
			else
			{
			
				colorNum = ( long ) ( row * width + col );
				hsvColor.hue = 65535 * colorNum / ( width * height );
				HSV2RGB ( &hsvColor, &curColor );
				
			}
			
			RGBForeColor ( &curColor );
			PaintRect ( &r );
			
		}
		
	}
	
}


/***************CenterWindow**************************************************/

void	CenterWindow ( w, boundsPtr )

Rect		*boundsPtr;
WindowPtr	w;
{

	Rect		r;
	int			width, height, sWidth, sHeight, h, v;
	
	r = w -> portRect;
	width = r.right - r.left;
	height = r.bottom - r.top;
	
	sWidth = boundsPtr -> right - boundsPtr -> left;
	sHeight = boundsPtr -> bottom - boundsPtr -> top;
	
	h = boundsPtr -> left + ( ( sWidth - width ) / 2 );
	v = boundsPtr -> top + ( ( sHeight - height ) / 2 );
	
	MoveWindow ( w, h, v, false );
	
}


/***************DoError*******************************************************/

void	DoError( Str255 errorString )
{
	ParamText( errorString, "\p", "\p", "\p" );
	
	StopAlert( kErrorALRTid, kNullFilterProc );
	
	ExitToShell();
}					


