/************************************************************/
/*												        */								
/*			Palette Code from Chapter Four of			        */
/*												        */													
/*	*** The Macintosh Programming Primer, Volume II ***		        */
/*												        */														
/*	  Copyright 1990, 1996 Dave Mark, All Rights Reserved...	        */
/*												        */														
/************************************************************/
/************************************************************/
/*												        */														
/*       	Code converted from THINK C to CodeWarrior		        */
/*                         									        */														
/*						by                   				        */		            
/*												        */														
/*                			  Mike Murry                        	                           */
/*												        */														
/************************************************************/

#include	<Palettes.h>

#define		kBaseResID					400
#define		kNilPointer					0L
#define		kNilString					"\p"
#define		kVisible					true
#define		kHasGoAway				true
#define		kMoveToFront				( WindowPtr ) -1L
#define		kRemoveAllEvents			0
#define		kSleep					0L
#define		kNilMouseRegion				0L
#define 	         kErrorALRTid				128
#define 		kNullFilterProc				NULL

#define		kPreciseTolerance			0x0000
#define		kNumSquares				150


/************************************************************/
/*          			        Globals 						        */        	          	
/************************************************************/

Boolean		gDone;

/************************************************************/
/*          			        Functions 						        */                  	
/************************************************************/

void				ToolboxInit ( void );
void				EventLoop ( void );
void				DoEvent ( EventRecord *eventPtr );
void				DrawBullsEye ( void );
Boolean			HasColorQD ( void );
WindowPtr			CreateColorWindow ();
void				DoError( Str255 errorString );

pascal 	void 		PmForeColor (short 	dstEntry);
															
pascal 	void 		InitPalettes (void);

pascal	PaletteHandle	MakeRedPalette ( void );
pascal	PaletteHandle	MakeBrightPalette ( void );
pascal	PaletteHandle	MakeGrayPalette ( void );



/***************************main****************************/

void		main ( void )
{

	Point				corner;
	WindowPtr			window;
	PaletteHandle		pal;
	
	ToolboxInit ();
	
	if ( ! HasColorQD () )
	{
	
		DoError ( "\pThis machine does not support Color QuickDraw!" );
		
	}
	
	else
	{
	
		corner.h = 10;
		corner.v = 40;
		window = CreateColorWindow ( corner, "\pRed Palette" );
		pal = MakeRedPalette ();
		SetPalette ( window, pal, true );
		
		corner.h = 170;
		corner.v = 177;
		window = 	CreateColorWindow ( corner, "\pBright Palette" );
		pal = MakeBrightPalette ();
		SetPalette ( window, pal, true );
		
		corner.h = 330;
		corner.v = 40;
		window = 	CreateColorWindow ( corner, "\pGray Palette" );
		pal = MakeGrayPalette ();
		SetPalette ( window, pal, true );
		
		EventLoop ();
		
	}
	
}


/************************TollboxInit********************************/

void	ToolboxInit ()
{

	InitGraf ( &qd.thePort );
	InitFonts();
	FlushEvents ( everyEvent, kRemoveAllEvents );
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs( 0L );
	InitCursor();	
	
}


/******************************** EventLoop **********************/

void	EventLoop( void )
{		
	EventRecord	event;
	
	gDone = false;
	while ( gDone == false )
	{
		if ( WaitNextEvent( everyEvent, &event, kSleep, NULL ) )
		{
			
			DoEvent( &event );
			
		}	
	}
}

/***********************DoEventLoop*******************************/

void	DoEvent ( EventRecord *eventPtr )
{

	short			thePart;
	WindowPtr		window;
	
	
	
	switch ( eventPtr -> what )
	{
		
		case mouseDown:
			thePart = FindWindow ( eventPtr -> where, &window );
				
			if ( thePart == inGoAway )
			{
				
				gDone = true;
					
			}
				
			else if ( thePart == inDrag )
			{
			
				DragWindow ( window, eventPtr -> where, &qd.screenBits.bounds );
					
			}
			
			else if ( thePart == inContent )
			{
				
				if ( window != FrontWindow () )
				{
					
					SelectWindow ( window );
						
				}
					
			}
			break;
				
		case updateEvt:
			window = ( ( WindowPtr ) eventPtr -> message );
			
			BeginUpdate  ( window );
			SetPort 	( window );
			DrawBullsEye ();
			EndUpdate ( window );
			
			break;
				
		
	}
		
}


/*******************DrawBullsEye*******************************/

void		DrawBullsEye ( )
{
	
	int		i, center;
	Rect		rect;
	
	center = kNumSquares;
	
	for ( i=1; i <= kNumSquares; i++ )
	{
	 
		PmForeColor ( i - 1 );
		rect.top = center - i;
		rect.left = center - i;
		rect.bottom = center + i;
		rect.right = center + i;
		
		FrameRect ( &rect );
		
	}
	
}


/****************** HasColorQD **********************************************/

Boolean			HasColorQD ( void )
{
	unsigned char	version[ 4 ];
	OSErr		err;
	
	err = Gestalt( gestaltQuickdrawVersion, (long *)version );
	
	if ( version[ 2 ] > 0 )
	{
		
		return( true );
		
	}	
	
	else
	{
		
		return( false );
		
	}	

}


/******************MakeRedPalette******************************************/

pascal	PaletteHandle	MakeRedPalette ( void )
{

	RGBColor				c;
	long					i;
	PaletteHandle			redPalette;
	
	redPalette = NewPalette ( kNumSquares, kNilPointer, pmTolerant, kPreciseTolerance );

	c.green = 0;
	c.blue    = 0;
	
	for ( i=0;  i < kNumSquares;  i++ )
	{
	
		c.red = ( i * 65535 ) / kNumSquares;
		SetEntryColor ( redPalette, i, &c );
		
	}
	
	return ( redPalette );
	
}


/******************MakeBrightPalette**********************************/

pascal	PaletteHandle	MakeBrightPalette ( void )
{

	PaletteHandle				brightPalette;
	long						i;
	RGBColor					rgbColor;
	HSVColor					hsvColor;
	
	brightPalette = NewPalette ( kNumSquares, kNilPointer, pmTolerant, kPreciseTolerance );

	hsvColor.value = 65535;
	hsvColor.saturation = 65535;
	
	for ( i=0;  i < kNumSquares;  i++ )
	{
	
		hsvColor.hue = ( i * 65535 ) / kNumSquares;
		HSV2RGB ( &hsvColor, &rgbColor );
		SetEntryColor ( brightPalette, i, &rgbColor );
		
	}
	
	return ( brightPalette );
	
}


/*********************MakeGrayPalette********************************/

pascal	PaletteHandle	MakeGrayPalette ( void )
{

	PaletteHandle			grayPalette;
	long					i;
	RGBColor				rgbColor;
	
	grayPalette = NewPalette ( kNumSquares, kNilPointer, pmTolerant, kPreciseTolerance );

	for ( i = 0;  i < kNumSquares;  i++ )
	{
	
		rgbColor.red = ( i * 65535 ) / kNumSquares;
		rgbColor.green = rgbColor.red;
		rgbColor.blue = rgbColor.red;
		SetEntryColor ( grayPalette, i, &rgbColor );
		
	}
	
	return ( grayPalette );
	
}


/******************CreateColorWindow*****************************/

WindowPtr		CreateColorWindow ( corner, title )

Point				corner;
Str255			title;
{

	WindowPtr			cWindow;
	Rect				r;
	
	SetRect ( &r, corner.h, corner.v, corner.h + ( 2 * kNumSquares ), corner.v + ( 2 * kNumSquares ) );

	cWindow = NewCWindow ( kNilPointer, &r, title, kVisible, noGrowDocProc, kMoveToFront, kHasGoAway, kNilPointer );

	return ( cWindow );
	
}


/***************DoError*******************************************************/

void	DoError( Str255 errorString )
{
	ParamText( errorString, "\p", "\p", "\p" );
	
	StopAlert( kErrorALRTid, kNullFilterProc );
	
	ExitToShell();
}								
			
